
/* IIC-COM.C:  IIC-BUS COMMUNICATION */

#define Clock_4MHz

#pragma bit scl_IIC @ PORTB.3
#pragma bit sda_IIC @ PORTB.4
#define  WRITE_sda()  TRISB = 0xE7 /* xxx0 0xxx */
#define  READ_sda()   TRISB = 0xf7 /* xxx1 0xxx */

#define  _address_RW_0   0xa2
#define  _address_RW_1   0xa3

char  IIC_byte;
bit   IIC_error, master_ack;


#include <iicbus.c>

char aa,bb,cc;

void read_IIC( char address)
/* reads 3 bytes from the IIC device */
{
    startIICcomm();
    sendIICbyte( _address_RW_0);
    sendIICbyte( address);
    stopIICcomm();

    startIICcomm();
    sendIICbyte( _address_RW_1);

    master_ack = 0;
    readIICbus();  aa = IIC_byte;
    readIICbus();  bb = IIC_byte;
    master_ack = 1;
    readIICbus();  cc = IIC_byte;
    stopIICcomm();
}

void write_IIC( char address,char lb)
/* writes 1 byte variables to the IIC device */
{
    startIICcomm();
    sendIICbyte( _address_RW_0);
    sendIICbyte( address);

    sendIICbyte(aa);
    if(lb>1)
    sendIICbyte(bb);
    if(lb==3)
    sendIICbyte(cc);
    stopIICcomm();
}

