#include <16f76.h>
#include "a_pc.h"
int data[1];
main()
{
int i;
int vol1;
int vol2;

	set_tris_a(0);//wszystkie linie wyjciowe
	set_tris_b(0xd8);//RB3, RB4 i RB6 wejsciowe (impulsator)
	set_tris_c(4);//wszystkie linie wyjsciowe oprocz RC2
	port_b_pullups(true);//podciaganie portb wlaczone
	setup_adc_ports (no_analogs);//wszystkie linie porta cyfrowe
	
	output_bit(PIN_B2,0);
	output_bit(PIN_C6,0);
	CLK1=0;
	CLK2=0;
	LATCH1=0;
	LATCH2=0;

	if(R_WYSW==1)//VFD
	 {output_bit(PIN_A0,1);//sck=1 (vfd)
	 output_bit(PIN_A3,1);//cs=1
	 inic_vfd();//inicjalizacja vfd
	 def_font();}
	else
	 inic_lcd();
	 
	if(rd_eeprom(100)!=0x73)
	{wr_eeprom(100,0x73);
	 for(i=0;i<30;i++)
	 wr_eeprom(i,0);
	 wr_eeprom(7,40);//wartosc poczatkowa temperatur
	 wr_eeprom(8,40);}
	
	if((rd_eeprom(6)&1)==1)
	{inp=1;//cztery kanay
	 LED_Q=1;
	 LED_S=0;}
	else
	{inp=0;//wejscie cyfrowe
	 LED_Q=0;
	 LED_S=1;}

	set_temp_config();//inicjalizacja TCN75
	send_temp(rd_eeprom(7),0);//zaprogramowanie termostatow
	send_temp(rd_eeprom(8),2);		
	delay_ms(40);		
	 poz_vfd(0);
	 wys_vfd("AVT PC A");
	 poz_vfd(8);
	 wys_vfd("MPLIFIER");
	 audio();
	delay_ms(2000);


	temp_alm=1;//odczyt alarmu temperatury
	while(1){
_et:	vol1=rd_eeprom(1);
	vol2=rd_eeprom(2);	
	poz_vfd(0);	
	wys_vfd("volume -");
	poz_vfd(8);
	wys_vfd("  dB    ");	
	wys_dzies(tab_vol_disp[vol1],8);
	
	poz_vfd(13);
	send_vfd(0x92);
	wys_vfd("Fu");	
	
	while(1){	
	i=impulsator();	
	if(i==3)
	{while(kl==1){
	 poz_vfd(0);
	 wys_vfd("t1  out ");
	 poz_vfd(8);
	 wys_vfd("of range");
	 delay_ms(400);
	 if(kl==0)
	 break;
	 poz_vfd(0);
	 wys_vfd("        ");
	 poz_vfd(8);
	 wys_vfd("        ");
	 delay_ms(300);}
	 temp_alm=0;
	 while(kl==0);
	 delay_ms(20);
	 goto _et;}
	if(i==2)
	break;
	if(i==1)
	{++vol1;
	 if(vol1==53)
	 vol1=52;
	 ++vol2;
	 if(vol2==53)
	 vol2=52;}
	if(i==0)
	{--vol1;
	 if(vol1==0xff)
	 vol1=0;
	 --vol2;

	 if(vol2==0xff)
	 vol2=0;
	 }
	wys_dzies(tab_vol_disp[vol1],8);
	wr_eeprom(1,vol1);
	wr_eeprom(2,vol2);
	audio();//ustawienie procesorow audio
	}
	temp_alm=0;
	sel_fun();
	temp_alm=1;
	}

}
void sel_fun()
{
int i,nr_fun;
	if(R_WYSW==1)
	{poz_vfd(8);//wyswietlenie menu wyboru 
	send_vfd(0x90);
	wys_vfd("sel  acc");
	poz_vfd(13);
	send_vfd(0x92);}
	else
	{poz_vfd(8);//wyswietlenie menu wyboru 	
	wys_vfd(" sel    ");
	poz_vfd(13);
	wr_data(0xec);	}

	nr_fun=rd_eeprom(0);
	while(1){	
	wys_fun(nr_fun);//wyswietlenie ostanio wybranej funkcji
	i=impulsator();
	if(i==1)//obrot w lewo
	{--nr_fun;
	if(nr_fun==0xff)
	nr_fun=8;
	continue;}
	if(i==0)//obrot w prawo
	{++nr_fun;
	 if(nr_fun==10)
	 nr_fun=0;
	 continue;}
	if(i==2)//przycisniecie galki
	{wr_eeprom(0,nr_fun);
	 if(nr_fun==0)
	 wyk_vol12();
	 if (nr_fun==1)
	 wyk_vol34();
	 if(nr_fun==2)
	 wyk_bass();
	 if(nr_fun==3)
	 wyk_treble();
	 if(nr_fun==4)
	 wyk_surr1();
	 if(nr_fun==5)
	 wyk_surr2();
	 if(nr_fun==6)
	 wyk_mo_qu();
	 if(nr_fun==7)
	 wyk_temp1();
	 if(nr_fun==8)
	 wyk_temp2();
	 if(nr_fun==9)
	 termometr();
	 return;}
	 }
		
	
}
void wyk_vol12()
{
int vol,i;
	vol=rd_eeprom(1);
	poz_vfd(0);
	wys_vfd("Vol 1,2 ");
	poz_vfd(8);
	wys_vfd("-  dB   ");

	wys_dzies(tab_vol_disp[vol],9);
	while(1){
	i=impulsator();
	if(i==2)
	break;
	if(i==1)
	{++vol;
	 if(vol==53)
	 vol=52;}
	if(i==0)
	{--vol;
	 if(vol==0xff)
	 vol=0;}
	wys_dzies(tab_vol_disp[vol],9);
	wr_eeprom(1,vol);
	send_audio(1);
	}	 
}
void wyk_vol34()
{
int vol,i;
		 
	vol=rd_eeprom(2);
	poz_vfd(0);
	wys_vfd("Vol 3,4 ");
	poz_vfd(8);
	wys_vfd("-  dB   ");

	wys_dzies(tab_vol_disp[vol],9);
	while(1){
	i=impulsator();
	if(i==2)
	break;
	if(i==1)
	{++vol;
	 if(vol==53)
	 vol=52;}
	if(i==0)
	{--vol;
	 if(vol==0xff)
	 vol=0;}
	wys_dzies(tab_vol_disp[vol],9);
	wr_eeprom(2,vol);
	send_audio(2);
	}	 
}
void wyk_bass()
{
int bass,i;
	bass=rd_eeprom(3);
	poz_vfd(0);
	wys_vfd("bass   ");
	while(1){
	poz_vfd(7);
	if(tab_tone_disp[bass]<0x0f)
	wys_vfd("+");
	else
	wys_vfd("-");
	poz_vfd(10);
	wys_vfd("dB    ");
	wys_dzies((tab_tone_disp[bass]&0x3f),8);
	i=impulsator();
	if(i==1)
	{--bass;
	 if(bass==0xff)
	 bass=0;}
	if(i==0)
	{++bass;
	 if(bass==13)
	 bass=12;}
	if(i==2)
	return;
	wr_eeprom(3,bass);
	audio();//ustawienie procesorow audio	
	}
}	 
void wyk_treble()
{
int treble,i;
	treble=rd_eeprom(4);
	poz_vfd(0);
	wys_vfd("treble  ");
	while(1){
	poz_vfd(7);
	if(tab_tone_disp[treble]<0x0f)
	wys_vfd("+");
	else
	wys_vfd("-");
	poz_vfd(10);
	wys_vfd("dB    ");
	wys_dzies((tab_tone_disp[treble]&0x3f),8);
	i=impulsator();
	if(i==1)
	{--treble;
	 if(treble==0xff)
	 treble=0;}
	if(i==0)
	{++treble;
	 if(treble==13)
	 treble=12;}
	if(i==2)
	return;
	wr_eeprom(4,treble);
	audio();//ustawienie procesorow audio
	}
}
void wyk_surr1()
{
int surr;
	surr=rd_eeprom(5);
	poz_vfd(0);
	wys_vfd("SURR.1  ");
	while(1){
	poz_vfd(8);
	if((surr&1)==1)
	wys_vfd("NO      ");
	else
	wys_vfd("YES     ");
	if(impulsator()==2)
	 return;
	if((surr&1)==1)
	surr=surr&0xfe;
	else
	surr=surr|1;
	wr_eeprom(5,surr);
	audio();
	}
}
void wyk_surr2()
{
int surr;
	surr=rd_eeprom(5);
	poz_vfd(0);
	wys_vfd("SURR.2  ");
	while(1){
	poz_vfd(8);
	if((surr&2)==2)
	wys_vfd("NO      ");
	else
	wys_vfd("YES     ");
	if(impulsator()==2)
	 return;
	if((surr&2)==2)
	surr=surr&0xfd;
	else
	surr=surr|2;
	wr_eeprom(5,surr);
	audio();
	}
}
void wyk_mo_qu()
{
int s_q;
	s_q=rd_eeprom(6);
	poz_vfd(0);
	wys_vfd("MODE    ");
	while(1){
	poz_vfd(8);
	if(s_q==0)
	wys_vfd("CD-ROM  ");
	else
	wys_vfd("QUADRO  ");
	if(impulsator()==2)
	 return;
	if(s_q==1)
	s_q=0;
	else
	s_q=1;
	wr_eeprom(6,s_q);
	if(s_q==1)
	{inp=1;//cztery kanay
	 LED_Q=1;
	 LED_S=0;}
	else
	{inp=0;//wejscie cyfrowe
	 LED_Q=0;
	 LED_S=1;}
	audio();
	}

}
void wyk_temp1()
{
int temp,i;
	
	temp=rd_eeprom(7);//temperatura1
	poz_vfd(0);
	wys_vfd("temp.1  ");
	poz_vfd(8);
	wys_vfd("  C     ");
	while(1){
	wys_dzies(temp,8);
	send_temp(temp,0);
	i=impulsator();
	if(i==1)
	{--temp;
	 if(temp==9)
	  temp=10;}
	if(i==0)
	{++temp;
	 if(temp==100)
	 temp=99;}
	if(i==2)
	return;
	wr_eeprom(7,temp);	
	}
}
void wyk_temp2()
{
int temp,i;
	
	temp=rd_eeprom(8);//temperatura2
	poz_vfd(0);
	wys_vfd("temp.2  ");
	poz_vfd(8);
	wys_vfd("  C     ");
	while(1){
	wys_dzies(temp,8);
	send_temp(temp,2);

	i=impulsator();
	if(i==1)
	{--temp;
	 if(temp==9)
	  temp=10;}
	if(i==0)
	{++temp;
	 if(temp==100)
	 temp=99;}
	if(i==2)
	 return;
	 wr_eeprom(8,temp);
	}
}

void wys_fun(int nr_fun)
{
	poz_vfd(0);
	if(nr_fun==0)
	wys_vfd("Vol 1,2 ");  
	if(nr_fun==1)
	wys_vfd("Vol 3,4 "); 
	if(nr_fun==2)
	wys_vfd("Bass    ");
	if(nr_fun==3)
	wys_vfd("Treble  ");
	if(nr_fun==4)
	wys_vfd("Surr. 1 ");
	if(nr_fun==5)
	wys_vfd("Surr. 2 ");
	if(nr_fun==6)
	wys_vfd("Ch. 2/4 ");
	if(nr_fun==7)
	wys_vfd("temp 1  ");
	if(nr_fun==8)
	wys_vfd("temp 2  ");
	if(nr_fun==9)
	wys_vfd("termom. ");
}
void wys_dzies(int wartosc,int poz)
{
int ldzies,ljedn;
	poz_vfd(poz); 
	ldzies=wartosc/10;
	if(R_WYSW==1)
	send_vfd(ldzies+0x30);
	else
	wr_data(ldzies+0x30);
	ldzies=ldzies*10;
	wartosc=wartosc-ldzies;	
	if(R_WYSW==1)
	send_vfd(wartosc+0x30);
	else
	wr_data(wartosc+0x30);
	
}
void wys_hex(int wartosc,int poz)
{
int lhex,ljedn;
	poz_vfd(poz); 
	lhex=wartosc/16;
	if(lhex<10)
	send_vfd(lhex+0x30);
	else
	send_vfd(lhex+0x37);
	lhex=lhex*16;
	wartosc=wartosc-lhex;
	if(wartosc<10)	
	send_vfd(wartosc+0x30);
	else
	send_vfd(wartosc+0x37);
	
}
void audio()
{
	send_audio(1);
	send_audio(2);
}
void send_audio(int nr_p)
{
int i;
int volume,bass,treble,surr;

	if(nr_p==1)
	volume=tab_vol[rd_eeprom(1)];//kanaly 1,2
	else
	{if(rd_eeprom(6)==1)//tryb quadro
	 volume=tab_vol[rd_eeprom(2)];//kanaly 3,4
         else
	 volume=0;}//mute kan.3,4 tryb stereo

	bass=tab_tone_b[rd_eeprom(3)];	
	treble=tab_tone_t[rd_eeprom(4)];
	surr=rd_eeprom(5); 
	
	if(nr_p==1)
	{
	for(i=0;i<8;i++)
	{CLK1=0;
	 if((volume&0x80)==0x80)	
	 output_bit(PIN_B2,1);
	 else
	 output_bit(PIN_B2,0);
	 CLK1=1;
	 volume=volume<<1;
	 }
	for(i=0;i<5;i++)
	{CLK1=0;
         if((treble&0x10)==0x10)
	 output_bit(PIN_B2,1);
	 else
	 output_bit(PIN_B2,0);
	 CLK1=1;
	 treble=treble<<1;
	}
	for(i=0;i<5;i++)
	{CLK1=0;
         if((bass&0x10)==0x10)
	 output_bit(PIN_B2,1);
	 else
	 output_bit(PIN_B2,0);
	 CLK1=1;
	 bass=bass<<1;
	}
	for(i=0;i<6;i++)
	{CLK1=0;
         if((surr&0x1)==1)
	 output_bit(PIN_B2,1);
	 else
	 output_bit(PIN_B2,0);
	 CLK1=1;
	 surr=surr>>1;
	}
	volume=0x57;	
	for(i=0;i<8;i++)
	{CLK1=0;
	 if((volume&0x80)==0x80)	
	 output_bit(PIN_B2,1);
	 else
	 output_bit(PIN_B2,0);
	 CLK1=1;
	 volume=volume<<1;
	 }
	}//end if....
	else
	{
	for(i=0;i<8;i++)
	{CLK2=0;
	 if((volume&0x80)==0x80)	
	 output_bit(PIN_C6,1);
	 else
	 output_bit(PIN_C6,0);
	 CLK2=1;
	 volume=volume<<1;
	 }
	for(i=0;i<5;i++)
	{CLK2=0;
         if((treble&0x10)==0x10)
	 output_bit(PIN_C6,1);
	 else
	 output_bit(PIN_C6,0);
	 CLK2=1;
	 treble=treble<<1;
	}
	for(i=0;i<5;i++)
	{CLK2=0;
         if((bass&0x10)==0x10)
	 output_bit(PIN_C6,1);
	 else
	 output_bit(PIN_C6,0);
	 CLK2=1;
	 bass=bass<<1;
	}
	for(i=0;i<6;i++)
	{CLK2=0;
         if((surr&0x1)==1)
	 output_bit(PIN_C6,1);
	 else
	 output_bit(PIN_C6,0);
	 CLK2=1;
	 surr=surr>>1;
	}
	volume=0x57;	
	for(i=0;i<8;i++)
	{CLK2=0;
	 if((volume&0x80)==0x80)	
	 output_bit(PIN_C6,1);
	 else
	 output_bit(PIN_C6,0);
	 CLK2=1;
	 volume=volume<<1;
	 }

	}//end else.....
	CLK1=0;
	CLK2=0;
	output_bit(PIN_B2,0);
	output_bit(PIN_C6,0);
	
	delay_us(5);

	if(nr_p==1)
	{LATCH1=1;
	delay_cycles(4);
	LATCH1=0;}
	else
	{LATCH2=1;
	delay_us(2);
	LATCH2=0;}
	
}
int impulsator() 
{ 
 	 
 	while(1){ 
 	if(temp_alm==1) 
 	{if(alm==0) 
 	 return(3);}//powrt z alarmem 

 _err:	if(kl==0) 
 	{delay_ms(20); 
 	 while(kl==0);//czekaj na puszczenie galki 
 	 delay_ms(20); 
 	 return(2);} 
 	 
 	if(SA==1&&SB==0)  
 	{if(temp_alm==1) 
 	  {if(alm==0) 
 	  return(3);}//powrt z alarmem 
 	 delay_ms(4); 
 	 while(1) 
 	  { 
 	  if(SA==1&&SB==0) 
 	  {if(kl==0) 
 	  {delay_ms(20); 
 	  while(kl==0);//czekaj na puszczenie galki 
 	  delay_ms(20); 
 	  return(2);} 

 	  continue;} 
 	  delay_ms(4); 
 	  if(SA==1&&SB==1) 
           {delay_ms(4); 
 	   break;} 
 	  
 	  delay_ms(4); 
 	  if(SA==1&&SB==1) 
           {delay_ms(4); 
 	   break;} 
 	   goto _err; 
  
          } 
 	 while(1) 
	  {if(SA==1&&SB==1) 
 	   {if(kl==0) 
 	   {delay_ms(20); 
 	    while(kl==0);//czekaj na puszczenie galki 
 	    delay_ms(20); 
 	    return(2);} 
 	    continue;} 
             delay_ms(4); 
 	    if(SA==0&&SB==1) 
              {delay_ms(4); 
 	     break;} 
		 
 	    delay_ms(4); 
	    if(SA==0&&SB==1) 
              {delay_ms(4); 
	     break;} 
	     goto _err; 

	 
           } 
	 while(1) 
	  {if(SA==0&&SB==1) 
	   {if(kl==0) 
	   {delay_ms(20); 
	   while(kl==0);//czekaj na puszczenie galki 
	   delay_ms(20); 
  	   return(2);} 
	   continue;} 
  
	   delay_ms(4); 
  
	   if(SA==0&&SB==0) 
             {delay_ms(4); 
	    return(0);}//zwieksz 

	    delay_ms(4); 
	    if(SA==0&&SB==0) 
             {delay_ms(4); 
	    return(0);}//zwieksz 
	    else 
	     goto _err; 
	     
	  } 
	} 
	if(SA==0&&SB==1) 
	{if(temp_alm==1) 
	 {if(alm==0) 
 	  return(3);}//powrt z alarmem 

 	 delay_ms(4); 
  	 while(1) 
 	 {if(SA==0&&SB==1) 
 	  {if(kl==0) 
 	  {delay_ms(20); 
 	  while(kl==0);//czekaj na puszczenie galki 
 	  delay_ms(20); 
 	  return(2);} 
 	  continue;} 
 	   
 	  if(SA==1&&SB==1) 
           {delay_ms(4); 
 	   break;} 
 	 
 	  delay_ms(4); 
 	  if(SA==1&&SB==1) 
           {delay_ms(4); 
 	   break;} 
 	   goto _err; 
  
          } 
 	 while(1) 
 	  {if(SA==1&&SB==1)
	   {if(kl==0) 
 	   {delay_ms(20); 
 	    while(kl==0);//czekaj na puszczenie galki 
 	    delay_ms(20); 
 	    return(2);}	 

 	    continue;}             	   
            delay_ms(4); 
 	   if(SA==1&&SB==0) 
            {delay_ms(4); 
 	    break;} 

 	    goto _err; 
           } 
  
 	 while(1)  
 	  {if(SA==1&&SB==0) 
 	   {if(kl==0) 
 	   {delay_ms(20); 
 	   while(kl==0);//czekaj na puszczenie galki 
 	   delay_ms(20); 
 	   return(2);} 
 	   continue;} 
             
 	   if(SA==0&&SB==0) 
             {delay_ms(4); 
 	    return(1);}//zwieksz  	    
            delay_ms(4); 
 	   if(SA==0&&SB==0) 
             {delay_ms(4); 

 	    return(1);}//zwieksz 
 	   goto _err; 
           } 
 	} 
 
 	} 

 }	 
void poz_vfd(int adres) 
{ 
	if(R_WYSW==1)	 
 	send_vfd(adres|0xe0); 
	else 
 	{if(adres>=8) 
 	 adres=(adres+0x38); 
 	 wr_cmd(adres|0x80);}//zapisz adres 
} 
 void wys_vfd(int napis) 
 {	 
 	if(R_WYSW==1) 
 	send_vfd(napis); 
 	else 
 	wr_data(napis); 
 }
void termometr() 
{ 
 int16 sr_temp; 
 int temp,i; 
  
 	poz_vfd(0); 

 	wys_vfd("Temp.   "); 
 	poz_vfd(8); 
 	wys_vfd("  C     "); 
 	while(1){ 
 	sr_temp=0; 
 	poz_vfd(8); 
 	for(i=0;i<10;i++) 
 	{temp=read_temp();  
 	sr_temp=sr_temp+temp;
 	delay_ms(100);} 
 	temp=sr_temp/10; 
 	wys_dzies(temp,8); 
 	if(kl==0) 
 	break; 
 	} 
 	while(kl==0);
	delay_ms(20);
 } 
 //odczytanie temperatury  
 int read_temp() 
 { 
 int temp; 
  
 	temp=0; 
 	i2c_start(); 
 	i2c_write(0x90); 
 	i2c_write(0);//pointer 
 	i2c_stop(); 
 	i2c_start();//repeat start 
 	i2c_write(0x91);//odczyt 
 	temp=i2c_read();	 
 	i2c_read(); 
 	i2c_stop(); 
 	return(temp); 
 } 
 void send_temp(int temp,int adres) 
 {  
 
 	i2c_start(); 
 	i2c_write(0x90|adres);//adres(a0...a2=0) 
 	i2c_write(3);	 
 	i2c_write(temp); 
 	i2c_write(0); 
 	i2c_stop(); 
 	 
 	i2c_start(); 
 	i2c_write(0x90|adres);//adres(a0...a2=0) 
 	i2c_write(2); 
 	temp=(temp-5);	 
 	i2c_write(temp); 
 	i2c_write(0); 
 	i2c_stop(); 
}
//inicjalizacja wyswietlacza vfd
void inic_vfd()
{
	send_vfd(0x07);//display lenght
	send_vfd(0x0d);//brightness
	send_vfd(0xf7);//320us
	send_vfd(0xe0);//adres 00
	send_vfd(0xf5);//autoincrement
	send_vfd(0xf1);//normal display mode
}
void send_vfd(int d_disp)
{
int i;
	data[0]=d_disp;	
	output_bit(PIN_A3,0);//CS=0
	for(i=0;i<8;i++)//wysylanie danej do vfd
	{output_bit(PIN_A0,0);
	 output_bit(PIN_A1,shift_left(data,1,0));
	 output_bit(PIN_A0,1);}//wpisanie danej
	output_bit(PIN_A3,1);//CS=1
	delay_ms(4);
}
void def_font()
{
	send_vfd(0xfc);//def UFD
	send_vfd(0);//0x90
	send_vfd(0x7c);
	send_vfd(0x82);
	send_vfd(0xaa);//aa
	send_vfd(0x6c);
	send_vfd(0xee);//ee

	send_vfd(0xfc);//def UFD
	send_vfd(1);//0x91 (rotacja)
	send_vfd(0x28);
	send_vfd(0x44);
	send_vfd(0x44);
	send_vfd(0x44);
	send_vfd(0x28);

	send_vfd(0xfc);//def UFD
	send_vfd(2);//0x92 (przycisk)
	send_vfd(0x14);
	send_vfd(0xf4);
	send_vfd(0xf0);
	send_vfd(0xf4);
	send_vfd(0x14);
}
void inic_lcd()
{
	delay_ms(50);//opoznienie 50msek
	RS=0;//rejestr IR
	dane_lcd(3);//ustaw 3 na RA0...RA3
	EN=1;
	delay_cycles(5);
	EN=0;
	delay_ms(6);
	EN=1;
	delay_cycles(5);
	EN=0;
	delay_us(150);
	EN=1;
	delay_cycles(5);
	EN=0;
	delay_us(150);

	dane_lcd(2);//ustaw 3 na RA0...RA3
	EN=1;
	delay_cycles(5);
	EN=0;
	
	wr_cmd(0x28);//function set
	wr_cmd(8);//display off
	wr_cmd(1);//display clear
	wr_cmd(6);//entry mod
	wr_cmd(0x0c);//display on
}
void wr_cmd(int cmd)
{
	RS=0;
	wr_lcd(cmd);
}
void wr_data(int data)
{
	RS=1;
	wr_lcd(data);
}
void wr_lcd(int dana)
{
int TMP;
	TMP=dana;
	EN=1;
	swap(TMP);	
	dane_lcd(TMP);//bardziej znaczacy polbajt
	EN=0;
	delay_cycles(2);//wpisanie do modulu
	EN=1;
	swap(TMP);
	dane_lcd(TMP);//mniej znaczacy polbajt
	EN=0;
	if(RS==1)
	delay_us(200);
	else
	delay_ms(3);
}

void dane_lcd(int dana)
{
	dana=dana&0x0f;
	porta=porta&0xf0;
	porta=porta|dana;
}
void wr_eeprom(int adres,int dana)
{
	i2c_start();	
	i2c_write(0xa0);
	i2c_write(adres);
	i2c_write(dana);
	i2c_stop();
	delay_ms(11);
	
}
//odczytanie danej z 24c04
int rd_eeprom(int adres)
{
	i2c_start();
	i2c_write(0xa0);
	i2c_write(adres);
	i2c_start();
	i2c_write(0xa1);//zmiana kierunku
	return(i2c_read(0));
}
 //zapisanie rejestru konfiguracji 
 void set_temp_config() 
 { 
 	i2c_start();//temp1 

 	i2c_write(0x90);//adres 

 	i2c_write(1); 
 	i2c_write(0x18); 
 	i2c_stop(); 

 	i2c_start();//temp2 
	i2c_write(0x92);//adres 
	i2c_write(1); 
 	i2c_write(0x1c); 
 	i2c_stop(); 
} 

